/*
 * Implementacio de les operacions sobre TauFreq
 */
#include <stdbool.h>
#include <assert.h>
#include <stdio.h>


#include "taufreq.h"

void CercaTF (TauFreq t, int zones, bool *const trobat, int *const pos);

void Inicialitzar (TauFreq *const t){
  (*t).nelem = 0;
}

void Afegir (TauFreq *const t, int zones){
  bool trobat;
  int pos;

  CercaTF (*t, zones, &trobat, &pos);
  if (trobat) {
    (*t).telem[pos].f = (*t).telem[pos].f + 1;
  }
  else if (!trobat) {
    /*insereix al final*/
    (*t).telem[pos].zones = zones;
    (*t).telem[pos].f = 1;
    (*t).nelem = (*t).nelem + 1;
  }
  else assert(0);
}

int Freq (TauFreq t, int zones){
  bool trobat;
  int pos;
  int f;

  CercaTF (t, zones, &trobat, &pos);
  if (trobat) {
    f = t.telem[pos].f;
  }
  else if (!trobat) {
    f = 0;
  }
  else assert(0);
  return f;
}

void CercaTF (TauFreq t, int zones, bool *const trobat, int *const pos){
  *pos = 1;
  *trobat = false;
  while (*pos  <= t.nelem && !*trobat){
    if (t.telem[*pos].zones == zones) {
      *trobat = true;
    }
    else if (t.telem[*pos].zones != zones){
     *pos = *pos + 1;
    }
    
    else assert(0);
  }
}
 


  

